

#import "AppDelegate.h"
#import "PhyUtility.h"
#import "SoundManager.h"
/* App version Update*/
#define df_ADHOCK_DOWN_USE            NO
#define NSEUCKRStringEncoding 0x80000000

@implementation AppDelegate

//@synthesize window = _window;


-(void)setRegisterNotification{
    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"UNPlUGGED" object:nil];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"PlUGGED" object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(readerUnplugged)
                                                 name:@"UNPlUGGED" object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(readerPlugged)
                                                 name:@"PlUGGED" object:nil];
    
}


-(void) readerUnplugged{
    
    if( self.navigation != nil)
        [self.navigation popToRootViewControllerAnimated:YES];
    
}

-(void) readerPlugged{
    
}


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
   // [UIApplication redirectConsoleLogToDocumentFolder:@"log.txt"];
    [[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications];
    [self setRegisterNotification];
    [self setSoundPath];
    return YES;
}

- (void)setSoundPath{

    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *path = paths[0];
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSError *error = nil;
    if ([fileManager fileExistsAtPath:path] == NO) {
        [fileManager createDirectoryAtPath:path withIntermediateDirectories:YES attributes:nil error:&error];
        if (error) {
            NSLog(@"%@",error.description);
        }
    }

    [self copyOriginalSound:path resource:@"read" type:@"caf"];
    [self copyOriginalSound:path resource:@"boyon1" type:@"mp3"];
    [self copyOriginalSound:path resource:@"kotsudumi1" type:@"mp3"];
    [self copyOriginalSound:path resource:@"drum-japanese2" type:@"mp3"];
    [self copyOriginalSound:path resource:@"trumpet1" type:@"mp3"];
    [self copyOriginalSound:path resource:@"decision17" type:@"mp3"];
    [self copyOriginalSound:path resource:@"decision15" type:@"mp3"];
    [self copyOriginalSound:path resource:@"decision5" type:@"mp3"];
    [self copyOriginalSound:path resource:@"asreader" type:@"wav"];

    NSString *toPath = [path stringByAppendingPathComponent:@"decision17.mp3"];
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    [defaults registerDefaults:@{@"sound":toPath}];
    [defaults synchronize];

    NSArray *files = [fileManager contentsOfDirectoryAtPath:path error:&error];
    if (error) {
        NSLog(@"%@",error.description);
    }

    NSLog(@"%@",files);
    for (NSString *file in files) {

        NSArray *fileCopmponents = file.pathComponents;
        NSString *fileName = fileCopmponents[fileCopmponents.count - 1];
        BOOL status = NO;
        for (NSDictionary *dic in [SoundManager sharedManager].originalSound) {
            for (NSString *key in dic.allKeys) {
                if ([key isEqualToString:fileName]) {
                    status = YES;
                }
            }
        }
        if (status  == NO) {
            NSLog(@"%@",file);
            NSString *fullPath = [path stringByAppendingPathComponent:file];
            [[SoundManager sharedManager]addItem:fullPath];
        }
    }
    NSUserDefaults *defauls = [NSUserDefaults standardUserDefaults];
    NSString *savedPath = [defauls objectForKey:@"sound"];
    NSString *theSaveName = [[savedPath lastPathComponent] lastPathComponent];
    for (NSString *filePath in [SoundManager sharedManager].dataSource) {
        NSString *fileName = [[filePath lastPathComponent] lastPathComponent];
             if ([theSaveName isEqualToString:fileName]) {
                NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
                [defaults setObject:filePath forKey:@"sound"];
                [defaults synchronize];
                 break;
            }
     }
}
- (void)copyOriginalSound:(NSString*)path resource:(NSString*)resource type:(NSString*)type{

    NSString *soundPath = [[NSBundle mainBundle] pathForResource:resource ofType:type];
    NSString *fileName = [NSString stringWithFormat:@"%@.%@",resource,type];
    NSString *toPath = [path stringByAppendingPathComponent:fileName];
    NSFileManager *fileManager = [NSFileManager defaultManager];

    if ([fileManager fileExistsAtPath:toPath] == NO) {
        NSError *error = nil;
        [fileManager copyItemAtPath:soundPath toPath:toPath error:&error];
        if (error) {
            NSLog(@"%@",error.description);
        }
    }

    [[SoundManager sharedManager]addItem:toPath];
}
//#pragma mark - UISceneSession lifecycle
//- (UISceneConfiguration *)application:(UIApplication *)application configurationForConnectingSceneSession:(UISceneSession *)connectingSceneSession options:(UISceneConnectionOptions *)options {
//    // Called when a new scene session is being created.
//    // Use this method to select a configuration to create the new scene with.
//    return [[UISceneConfiguration alloc] initWithName:@"Default Configuration" sessionRole:connectingSceneSession.role];
//}o9  
//9i//- (void)application:(UIApplication *)application didDiscardSceneSessions:(NSSet<UISceneSession *> *)sceneSessions {
//    // Called when the user discards a scene session.
//    // If any sessions were discarded while the application was not running, this will be called shortly after application:didFinishLaunchingWithOptions.
//    // Use this method to release any resources that were specific to the discarded scenes, as they will not return.
//}

- (void) registerRootNavigation:(UINavigationController *) navi
{
    self.navigation = navi;
    // [self.navigationController popToRootViewControllerAnimated:YES];
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    NSLog(@"applicationWillResignActive");
    if( self.navigation != nil) {
        [self.navigation popToRootViewControllerAnimated:YES];
    }
    //    NSNotification *notification = [NSNotification notificationWithName:@"applicationWillResignActive" object:self];
    //    [[NSNotificationCenter defaultCenter] postNotification:notification];
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    if( self.navigation != nil)
        [self.navigation popToRootViewControllerAnimated:YES];
    NSLog(@"applicationDidEnterBackground");
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    NSLog(@"applicationWillTerminate");
}

@end
